leetcode-392. Is Subsequence-DP-NORMAL
Given a string s and a string t, check if s is subsequence of t.
You may assume that there is only lower case English letters in both s and t. t is potentially a very long (length ~= 500,000) string, and s is a short string (<=100).
A subsequence of a string is a new string which is formed from the original string by deleting some (can be none) of the characters without disturbing the relative positions of the remaining characters. (ie, "ace"
is a subsequence of "abcde"
while "aec"
is not).
Example 1:
s = "abc"
, t = "ahbgdc"
Return true
.
Example 2:
s = "axc"
, t = "ahbgdc"
Return false
.
Follow up:
If there are lots of incoming S, say S1, S2, … , Sk where k >= 1B, and you want to check one by one to see if T has its subsequence. In this scenario, how would you change your code?
可用DP 贪心 二分查找。
1.最简单的做法,扫描一遍就好
if (s == "")return true; int index = 0; for (int i = 0; i < t.size(); i++) { if (s[index] == t[i]) { index++; if (index >= s.size())return true; } } return false;
2. 暴力递归搜索
bool f(int a, int b) { if (sa =="" )return true; if (a > sa.size())return true;//如果大于 那么表示前面所有的都匹配了因此true if (b > sb.size())return false;//b的index大于大小,意味着搜索完了还没return true因此false if (sa[a] == sb[b])//如果相同 那么直接递归下一个index { return f(a + 1, b + 1); } else { return f(a, b + 1);//不同则移动sb的index } }
3.吧暴力递归转换为DP
bool arr[10][10];//a b memset(arr, 0, 10 * 10); for (int b = 0; b < 10;b++)arr[0][b] = true;//初始化 字符串空 for (int a = sa.size(); a < 10; a++) { for (int b =0; b < 10; b++) arr[a][b] = true; // 初始化a>sa.size的情况 } for (int a = sa.size() - 1;a>=0; a--)//递推求解,递推公式和递归公式一样,但是循环条件是逆向,因为递归到底以后是倒着返回来的,所以递推要倒着 { for (int b = sb.size() - 1;b>=0; b--) { if (sa[a] == sb[b]) { arr[a][b] = arr[a + 1][b + 1]; } else { arr[a][b] = arr[a][b + 1]; } } } cout << arr[0][0] << endl; cout << f(0, 0) << endl;